<?php
/**************************************************************************
 *                                                                        *
 *    4images - A Web Based Image Gallery Management System               *
 *    ----------------------------------------------------------------    *
 *                                                                        *
 *             File: sessions.php                                         *
 *        Copyright: (C) 2002 Jan Sorgalla                                *
 *            Email: jan@4homepages.de                                    *
 *              Web: http://www.4homepages.de                             *
 *    Scriptversion: 1.7                                                  *
 *                                                                        *
 *    Never released without support from: Nicky (http://www.nicky.net)   *
 *                                                                        *
 **************************************************************************
 *                                                                        *
 *    Dieses Script ist KEINE Freeware. Bitte lesen Sie die Lizenz-       *
 *    bedingungen (Lizenz.txt) fr weitere Informationen.                 *
 *    ---------------------------------------------------------------     *
 *    This script is NOT freeware! Please read the Copyright Notice       *
 *    (Licence.txt) for further information.                              *
 *                                                                        *
 *************************************************************************/
if (!defined('ROOT_PATH')) {
  die("Security violation");
}

// Set here the URL to your IBF forum. WITH trailing slash!
$base_url = XOOPS_URL;

// Set here different URL's to your Invisionboard forum.
// Normally no need to change.
$url_register      = $base_url."/register.php";
$url_lost_password = $base_url."/user.php#lost.php";
$url_control_panel = $base_url."/edituser.php";
//$url_mailform      = "ROOT_PATH.'/../../ipboard/index.php?act=Mail&CODE=00&MID={user_id}";
$url_show_profile  = $base_url."/userinfo.php?uid={user_id}";
//$url_login         = $base_url."/user.php";
$url_logout        = $base_url."/user.php?op=logout";

//-----------------------------------------------------
//--- Start Configuration -----------------------------
//-----------------------------------------------------
define('SESSION_NAME', 'sessionid');


$user_table_fields = array(
  "user_id" => "uid",
  "user_level" => "level",
  "user_name" => "uname",
  "user_password" => "pass",
  "user_email" => "email",
  "user_showemail" => "user_viewemail",
  "user_allowemails" => "user_mailok",
  "user_invisible" => "",
  "user_joindate" => "user_regdate",
  "user_activationkey" => "actkey",
  "user_lastaction" => "",
  "user_location" => "user_location",
  "user_lastvisit" => "last_login",
  "user_comments" => "posts",
  "user_homepage" => "url",
  "user_icq" => "user_icq"
);

//-----------------------------------------------------
//--- End Configuration -------------------------------
//-----------------------------------------------------

function get_user_table_field($add, $user_field) {
  global $user_table_fields;
  return (!empty($user_table_fields[$user_field])) ? $add.$user_table_fields[$user_field] : "";
}

class Session {

  var $session_id;
  var $user_ip;
  var $user_location;
  var $current_time;
  var $session_timeout;
  var $mode = "get";
  var $session_info = array();
  var $user_info = array();

  function Session() {
    global $config;
    $this->session_timeout = $config['session_timeout'] * 60;
    $this->user_ip = $this->get_user_ip();
    $this->current_time = time();
    $this->demand_session();
  }

  function set_cookie_data($name, $value, $permanent = 1) {
    $cookie_expire = ($permanent) ? $this->current_time + 60 * 60 * 24 * 365 : 0;
    $cookie_name = COOKIE_NAME.$name;
    setcookie($cookie_name, $value, $cookie_expire, COOKIE_PATH, COOKIE_DOMAIN, COOKIE_SECURE);
  }

  function read_cookie_data($name) {
    global $HTTP_COOKIE_VARS;
    $cookie_name = COOKIE_NAME.$name;
    return (isset($HTTP_COOKIE_VARS[$cookie_name])) ? $HTTP_COOKIE_VARS[$cookie_name] : false;
  }

  function get_session_id() {
    global $HTTP_GET_VARS, $HTTP_POST_VARS, $sid_bb;
/*
    if ($this->session_id = $this->read_cookie_data("sid")) {
      $this->mode = "cookie";
    }
    else {
*/    	
    if ($sid_bb) {
      $this->session_id = $sid_bb;
    }
    else {
      if (isset($HTTP_GET_VARS[SESSION_NAME])) {
        $this->session_id = $HTTP_GET_VARS[SESSION_NAME];
      }
      elseif (isset($HTTP_POST_VARS[SESSION_NAME])) {
        $this->session_id = $HTTP_POST_VARS[SESSION_NAME];
      }
      else {
        $this->session_id = false;
      }
    }
  }

  function demand_session() {
  	global $uid_bb;
    $this->get_session_id();
    $this->load_session_info();
	$this->user_info = $this->load_user_info($uid_bb);
  }

	function isadmin(){
	  	global $uid_bb, $site_db;

	    $sql = $site_db->query("SELECT * FROM ".XOOPS_DB_PREFIX."_groups_users_link WHERE uid=".$uid_bb." AND groupid='1'");	
	    $row = $site_db->fetch_array($sql);
	    
	    if ($row['groupid']==1 && !empty($row['groupid'])){
	    	return 1;
		}
		return 0;
	}
	
  function login($user_name = "", $user_password = "", $auto_login = 0, $set_auto_login = 1) {
    global $site_db, $user_table_fields,$base_url;

    if (empty($user_name) || empty($user_password)) {
      return false;
    }
    $sql = "SELECT ".get_user_table_field("", "user_id").get_user_table_field(", ", "user_password")." 
            FROM ".USERS_TABLE." 
            WHERE ".get_user_table_field("", "user_name")." = '$user_name' AND ".get_user_table_field("", "user_level")." <> ".USER_AWAITING;
    $row = $site_db->query_firstrow($sql);
    
    $user_id = (isset($row[$user_table_fields['user_id']])) ? $row[$user_table_fields['user_id']] : GUEST;
    $user_password = md5($user_password);
    if ($user_id != GUEST) {
// XOOPS redirect login
		Header("location: ".$base_url."/user.php?op=login&uname=$user_name&pass=$user_password");
//		
    }
    return false;    
  }

  function logout($user_id) {
    global $site_db, $base_url;
    $this->set_cookie_data("userpass", "", 0);
    $this->set_cookie_data("userid", GUEST);
//XOOPS logout redirect
		Header ("Location: ".$base_url."/user.php?op=logout'");
//	    
    return true;
  }

  function return_session_info() {
    return $this->session_info;
  }

  function return_user_info() {
    return $this->user_info;
  }
  
  function freeze() {
    return;
  }

  function load_session_info() {
    global $site_db;

      $sql = "SELECT sessionvars_name, sessionvars_value 
              FROM ".SESSIONVARS_TABLE." 
              WHERE session_id = '$this->session_id'";
      $result = $site_db->query($sql);
      while ($row = $site_db->fetch_array($result)) {
        $this->session_info[$row['sessionvars_name']] = $row['sessionvars_value'];
      }
      return $this->session_info;
  }
  
  function load_user_info($user_id = GUEST) {
    global $site_db, $user_table_fields;

    if ($user_id != GUEST) {
      $sql = "SELECT u.*, l.* 
              FROM ".USERS_TABLE." u, ".LIGHTBOXES_TABLE." l 
              WHERE ".get_user_table_field("u.", "user_id")." = $user_id AND l.user_id = ".get_user_table_field("u.", "user_id");
      $user_info = $site_db->query_firstrow($sql);
      if (!$user_info) {
        $sql = "SELECT * 
                FROM ".USERS_TABLE." 
                WHERE ".get_user_table_field("", "user_id")." = $user_id";
        $user_info = $site_db->query_firstrow($sql);
        if ($user_info) {
          $lightbox_id = get_random_key(LIGHTBOXES_TABLE, "lightbox_id");
          $sql = "INSERT INTO ".LIGHTBOXES_TABLE." 
                  (lightbox_id, user_id, lightbox_lastaction, lightbox_image_ids) 
                  VALUES 
                  ('$lightbox_id', ".$user_info[$user_table_fields['user_id']].", $this->current_time, '')";
          $site_db->query($sql);
          $user_info['lightbox_lastaction'] = $this->current_time;
          $user_info['lightbox_image_ids'] = "";
        }
      }
    }
    if (empty($user_info[$user_table_fields['user_id']])) {
      $user_info = array();
      $user_info['user_id'] = GUEST;
      $user_info['user_level'] = GUEST;
      $user_info['user_lastaction'] = $this->current_time;
      $user_info['user_lastvisit'] = ($this->read_cookie_data("lastvisit")) ? $this->read_cookie_data("lastvisit") : $this->current_time;
    }
    foreach ($user_table_fields as $key => $val) {
      if (isset($user_info[$val])) {
        $user_info[$key] = $user_info[$val];
      }
      elseif (!isset($user_info[$key])) {
        $user_info[$key] = "";
      }
    }
    return $user_info;
  }

  function set_session_var($var_name, $value) {
    global $site_db;
    $sql = "SELECT session_id 
            FROM ".SESSIONVARS_TABLE." 
            WHERE sessionvars_name = '$var_name' AND session_id = '$this->session_id'";
    if ($site_db->is_empty($sql)) {
      $sql = "INSERT INTO ".SESSIONVARS_TABLE." 
              (session_id, sessionvars_name, sessionvars_value) 
              VALUES 
              ('$this->session_id', '$var_name', '$value')";
      $site_db->query($sql);
    }
    else {
      $sql = "UPDATE ".SESSIONVARS_TABLE." 
              SET sessionvars_value = '$value' 
              WHERE sessionvars_name = '$var_name' AND session_id = '$this->session_id'";
      $site_db->query($sql);
    }
    $this->session_info[$var_name] = $value;
    return true;
  }

  function get_session_var($var_name) {
    global $site_db;
    if (isset($this->session_info[$var_name])) {
      return $this->session_info[$var_name];
    }
    else {
      $sql = "SELECT sessionvars_value 
              FROM ".SESSIONVARS_TABLE." 
              WHERE sessionvars_name = '$var_name' AND session_id = '$this->session_id'";
      $value = $site_db->query_firstrow($sql);
      if ($value) {
        $this->session_info[$var_name] = $value['sessionvars_value'];
        return $value['sessionvars_value'];
      }
      else {
        return "";
      }
    }
  }

  function drop_session_var($var_name) {
    global $site_db;
    $sql = "DELETE FROM ".SESSIONVARS_TABLE." 
            WHERE sessionvars_name = '$var_name' AND session_id = '$this->session_id'";
    return ($site_db->query($sql)) ? 1 : 0;
  }

  function get_user_ip() {
    global $HTTP_SERVER_VARS, $HTTP_ENV_VARS;
    $ip = (!empty($HTTP_SERVER_VARS['REMOTE_ADDR'])) ? $HTTP_SERVER_VARS['REMOTE_ADDR'] : ((!empty($HTTP_ENV_VARS['REMOTE_ADDR'])) ? $HTTP_ENV_VARS['REMOTE_ADDR'] : getenv("REMOTE_ADDR"));
    $ip = preg_replace("/[^\.0-9]+/", "", $ip);
    return substr($ip, 0, 50);
  }

  function url($base_url, $amp = "&amp;") {
    global $l;
    $dummy_array = explode("#", $base_url);
    $base_url = $dummy_array[0];

    if ($this->mode == "get" && !preg_match("/".SESSION_NAME."=/i", $base_url)) {
      $base_url .= preg_match("/\?/", $base_url) ? "$amp" : "?";
      $base_url .= SESSION_NAME."=".$this->session_id;
    }

    if (!empty($l)) {
      $base_url .= preg_match("/\?/", $base_url) ? "$amp" : "?";
      $base_url .= "l=".$l;
    }

    $base_url .= (isset($dummy_array[1])) ? "#".$dummy_array[1] : "";
    return $base_url;
  }
} //end of class

//-----------------------------------------------------
//--- Start Session -----------------------------------
//-----------------------------------------------------
define('COOKIE_NAME', '4images_');
define('COOKIE_PATH', '/');
define('COOKIE_DOMAIN', '');
define('COOKIE_SECURE', '0');

$site_sess = new Session();

// Get Userinfo
$session_info = $site_sess->return_session_info();
$user_info = $site_sess->return_user_info();

if ($meminfo['level'] == 5){
	define('ADMIN', 5);
}else if ($site_sess->isadmin()) {
	define('ADMIN', 1);
}else {
	define('ADMIN', 99);
}
?>